
/** INF100, ving 6, oppgave 5.4
   Denne klassen representerer det enkle kortspillet som ble
   beskrevet, i oppgaven. Dette kortspillet
   trenger tre objekter: To spillere og en kortstokk.
*/
public class EnkeltKortspill 
{
    /**
       Et kortspill objekt har referanser til spillerene som
       deltar i spillet.
    */
    private Spiller spiller1, spiller2;
    
    /**
       Kortspill-objektet har referanse til kortstokk-objektet som
       blir brukt i spillet.
    */
    private Kortstokk kortstokken;

    /**
       Oppretter et nytt kortspill-objekt som vil arbeide p de to
       spiller-objektene og kortstokk-objektet som blir gitt inn
       som parameter.
    */
    public EnkeltKortspill(Kortstokk kortstokk,
               Spiller frsteSpiller,
               Spiller andreSpiller)
    {
    /*
      Denne konstruktren lagrer kun referansene til disse
      objektene i kortspill-objektet, slik at de er
      tilgjengelig nr det blir satt igang spilleomganger.
    */
    kortstokken = kortstokk;
    spiller1 = frsteSpiller;
    spiller2 = andreSpiller;

    }
    
    /**
       Spiller en omgang av kortspillet. Kortstokken som blir brukt og
       spillerene som deltar ble bestemt da kortspill-objektet ble
       opprettet.
    */
    public void spillOmgang() 
    {
            
    // 1. Stokker kortstokken tilfeldig:
    System.out.println( "Stokker om kortstokken." );
    kortstokken.stokkOm();
            
    // 2. Hver spiller fr et kort.
    System.out.println( "Deler ut et kort til hver spiller." );
    spiller1.settKort( kortstokken.trekkKort() );
    spiller2.settKort( kortstokken.trekkKort() );
            
    /* 
       3. Hver av spillerene fr muligheten til  bytte kortet
       sitt i et annet kort hvis de nsker. For  unng 
       gjenta samme kode om igjen for hver av spillerene
       legger vi koden som gir spillerene mulighet  bytte
       i en egen metode, hvor den aktuelle spilleren blir
       gitt inn som parameter.
    */
    giMulighetTilBytteKort( spiller1 );
    giMulighetTilBytteKort( spiller2 );
            
    /*
      4. Krer spilleren med kortet med strst kortverdi til
      vinner.
    */
    /* 
       Forteller hvilke kort de enkelte spillerene har. Igjen
       bruker vi en egen metode for  unng gjentakelse av
       kode.
    */
    skrivUtSpillerRapport( spiller1 );
    skrivUtSpillerRapport( spiller2 );
            
    // Finner vinneren:
    int poeng1 = poengTilSpiller( spiller1 );
    int poeng2 = poengTilSpiller( spiller2 );
            
    // Krer vinneren:
    if (poeng1 == poeng2) 
        {
        System.out.println( "Spillet endte uavgjort." );
    } 
        else 
        {
        Spiller vinneren;
        if (poeng1 > poeng2) 
        vinneren = spiller1;
        else
        vinneren = spiller2;
                    
        System.out.println( vinneren.hentNavn() + " vant." );
    }
    }
    
    /*
          Her kommer implementasjonen av hjelpemetodene som vi har brukt
          i spillOmgang metoden.
          */

        /**
          Gir spilleren som er gitt inn som parameter muligheten til 
          bytte kortet sitt hvis han/hun vil.
          */
    public void giMulighetTilBytteKort( Spiller aktuelleSpiller ) 
    {
    /* Legg merke til at vi her refererer et spiller-objekt
       gjennom referansen aktuelleSpiller isteden for 
       bruke refereansene spiller1 og spiller2 direkte.
       Dette gjr at denne metoden kan brukes p bde
       spiller1 og spiller2, bare ved  gi den aktuelle
       spilleren inn som argument.
    */
    if ( aktuelleSpiller.nskerBytteKort() ) 
        {
                    
        aktuelleSpiller.settKort( kortstokken.trekkKort() );
                    
        /*
          Legg merke til at vi her har tilgang til
          kortstokk-objektet selv om det ikke ble sendt
          inn som parameter til denne metoden. Det er
          fordi "kortstokken" er en instansevariabel og
          kan derfor brukes av alle instanse metodene i
          denne klassen.
        */
    }
    }
    
    /** 
    Skriver ut hvilket kort den aktuelle spilleren har p hnden.
    */
    public void skrivUtSpillerRapport( Spiller aktuelleSpiller ) 
    {
    System.out.println(
               aktuelleSpiller.hentNavn() + " har kortet " +
               aktuelleSpiller.hentKort().hentNavn()
               );
    }
    
    /**
       Regner ut hvor mange poeng kortet til den aktuelle spilleren
       er verd i dette kortspillet. Returnerer den kalkulerte
       poengverdien.
    */
    public int poengTilSpiller( Spiller aktuelleSpiller ) 
    {
    int kortVerdi = aktuelleSpiller.hentKort().hentVerdi();
    
    /*
      Den eneste forskjellen mellom kortverdi til kort
      og poengverdi i dette kortspillet er at
      ess har en kortverdi p 1 (=Kort.ESS), men har en
      poengverdi i dette spillet p 14.
    */
    switch (kortVerdi) 
        {
       case Kort.ESS:
               return 14;
         default:
           return kortVerdi;
    }
    // Kontrollflyten nr aldri hit.
    }    
    
} // Slutt p klassen EnkeltKortspill

