/** INF100, ving 6, oppgave 5.3
   
   En klasse som representerer spillekort.
   
   <p>I denne klassen
   representeres kortene med flgende verdier: Ess = 1, 2 = 2, 3 = 3,
   ..., knekt = 11, dame = 12, konge = 13.
   
   <p>Fargene representers ved:
   Spar = 0, hjerter = 1, klver = 2, og ruter = 3.
*/
      
public class Kort 
{

    /*
      Noen nyttige konstanter. Metoder i andre klasser kan referere
      til disse konstante verdiene ved Kort.KONSTANT_NAVN, f.eks.
      Kort.ESS.
      "static" betyr at disse er verdier som lagres i selve
      Kort klassen, istedet for i instanser av Kort klassen. Det er
      derfor andre klasser kan f tilgang til disse verdiene uten 
      opprette et kort-objekt frst.
      "final" betyr rett og slett at disse verdiene ikke kan endres,
      dvs. er konstante.
    */
    public final static int ESS   = 1;
    public final static int KNEKT = 11;
    public final static int DAME  = 12;
    public final static int KONGE = 13;

    public final static int FRSTE_VERDI = ESS;
    public final static int SISTE_VERDI  = KONGE;

    public final static int SPAR    = 0;
    public final static int HJERTER = 1;
    public final static int KLVER  = 2;
    public final static int RUTER   = 3;
    
    public final static int FRSTE_FARGE = SPAR;
    public final static int SISTE_FARGE  = RUTER;
    
    /*
      Her har vi et par konstante tabeller som ligger i selve Kort
      klassen.
     */
    final static String[] farger = { "Spar", "Hjerter", "Klver", "Ruter" };
    final static String[] verdier = {
	"-ubrukt-",
	"Ess", "2", "3", "4", "5", "6", "7", "8", "9", "10",
	"Knekt", "Dame", "Konge"
    };

    /*
      Variablene "verdien" og "fargen" er vanlige instanse variable.
      Hvert kort-objekt vil ha sin egen utgave av disse variablene.
      Man ser forskjellen mellom klasse variable og instanse variable
      ved at klasse variable har nkkelordet "static" foran
      deklarasjonen sin.
    */
    /**
       Verdien til kortet. Enten ESS, 2, 3, ..., KNEKT, DAME eller
       KONGE.
    */
    private int verdien;
    private int fargen;

    /**
       Denne konstruktren oppretter et kort-objekt som er av den
       verdi og farge som blir gitt inn som parameter.
    */
    public Kort( int verdi, int farge ) 
    {
        verdien = verdi;
        fargen = farge;
    }

    /** Returnerer verdien til kortet. */
    public int hentVerdi() 
    {
        return verdien;
    }

    /** Returnerer fargen til kortet. */
    public int hentFarge() 
    {
        return fargen;
    }

    /**
       Returnerer en streng som inneholder navnet til kortet, f.eks.
       "Ruter-8".
    */
    public String hentNavn() 
    {
        return farger[ fargen ] + "-" + verdier[ verdien ];
    }
}
