
/** INF100, ving 6, oppgave 5.3
   Denne klassen representerer en klassisk kortstokk med 52 kort.
   Det er mulig  stokke om kortstokken tilfeldig og trekke kort
   fra kortstokken.
*/

public class Kortstokk 
{

    /**
       En tabell som representerer alle kortene i kortstokken.
       Kortet kortene[0] ansees for  vre i bunnen av kortstokken, mens
       kortet kortene[antallKort-1] ansees for  vre p toppen av kortstokken.
    */
    private Kort[] kortene;

    /**
       Antall kort som ligger i kortstokken for yeblikket.
    */
    private int antallKort;

    /**
       Oppretter en ny kortstokk med 52 kort. Denne kortstokken er ikke
       tilfeldig stokket.
    */
    public Kortstokk()
    {
        kortene = new Kort[52];
        antallKort = 0;
        for (int farge = Kort.FRSTE_FARGE;
	     farge <= Kort.SISTE_FARGE;
	     farge++)
	{
	    for (int verdi = Kort.FRSTE_VERDI;
		 verdi <= Kort.SISTE_VERDI;
		 verdi++)
	    {
		kortene[ antallKort++ ] = new Kort( verdi, farge );
	    }
        }
    }
    
    /**
       Stokker om kortstokken, slik at alle kortene ligger i en helt
       tilfeldig rekkeflge. Denne metoden fungerer selv om ikke alle
       kortene ligger i kortstokken for yeblikket.
    */
    public void stokkOm() 
    {
	// Arbeider oss baklengs gjennom kortstokken:

        for (int i = antallKort-1; i > 1; i--) 
	{

	    /* 
	       P dette punktet i programmet antar vi at alle
	       kortene mellom indeks i+1 og antallkort-1 er
	       stokket om tilfeldig, og vi vil at alle kortene
	       mellom indeks i og antallkort-1 skal vre stokket
	       om tilfeldig. Dette oppnr vi ved  bytte kortet
	       som ligger ved indeks i mot et tilfeldig kort i
	       den ikke omstokkede delen av kortstokken, dvs
	       mellom indeks 0 og i-1.
	    */
	    
	    int rnd = (int) (Math.random() * i);
	    
	    // Bytt om p kort ved i og kort ved rnd
	    Kort temp = kortene[ i ];
	    kortene[ i ] = kortene[ rnd ];
	    kortene[ rnd ] = temp;
        }
    }

    /**
       Fjerner det verste kortet fra kortstokken og returnerer det.
    */
    public Kort trekkKort() 
    {
        antallKort--;
        return kortene[antallKort];
    }
}
